/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package br.com.integrator.dao;


import br.com.cliente.Cliente;
import br.com.integrator.util.ConnectionFactory;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;



public class ClienteDAOImp implements DAO {
    private Connection conn;
    
     /**
     * construtor que se conecta ao banco de dados
     * @throws java.lang.Exception se não houver conexão
     */
    public ClienteDAOImp( ) throws Exception{
        try {
            this.conn = ConnectionFactory.getConnection( );
            
            
        } catch( Exception e ) {
            throw new Exception( "Erro: " +
                    "\n" + e.getMessage( ) );
        }  }
     /**
     * Método que insere dados na tabela Clientes
     *  * @throws java.lang.Exception se não conseguir inserir
     */  
    public void salvar(Cliente cliente)  throws Exception{
        PreparedStatement ps = null;
        Connection conn = null;
        if (cliente == null)throw new   Exception("O valor passado não pode ser nulo");
        
        try {
            String SQL = "INSERT INTO cliente (nome, email) "+
                         "values (?, ?)";
            conn = this.conn;
            ps = conn.prepareStatement(SQL);
            ps.setString(1, cliente.getNome());
            ps.setString(2, cliente.getEmail( ));           

            ps.executeUpdate( );
            
        } catch (SQLException sqle) {
            throw new
                    Exception("Erro ao inserir dados "+ sqle);
        } finally {
            ConnectionFactory.closeConnection(conn, ps);
            
        }
    }
    
    /**
     * Método que atualiza os dados na tabela Autores
     * @param autor - recebe o objeto Autores
     * @throws java.lang.Exception se não for possível atualizar
     */    
  /*  public void atualizar(Autor autor)  throws Exception {
        PreparedStatement ps = null;
        Connection conn = null;
        
        if (autor == null)
            throw new
                    Exception("O valor passado não pode ser nulo");
        
        try {
            String SQL = "UPDATE autores SET nome=?, " +
                    " email=?, " +
                    "nascimento=? " +
                    "where id=?";
            conn = this.conn;
            ps = conn.prepareStatement(SQL);
            ps.setString(1, autor.getNome( ));
            ps.setString(2, autor.getEmail( ));
            ps.setDate(3, 
						new java.sql.Date(autor.getNascimento(  ).getTime()) 
					);
            ps.setInt(4, autor.getId( ));

            ps.executeUpdate( );
            
        } catch (SQLException sqle) {
            throw new
                    Exception("Erro ao atualizar dados: "+ sqle);
        } finally {
            ConnectionFactory.closeConnection(conn, ps);
            
        }
    } */
     
    
    /**
     * Método que retorna todos os autores
     * @return objeto List
     * @throws java.lang.Exception se não for possível retornar o objeto List
     */
  /*  public List todosAutores( )  throws Exception{
        PreparedStatement ps = null;
        Connection conn = null;
        ResultSet rs = null;
        
        try {
            conn = this.conn;
            ps = conn.prepareStatement("select * from autores");
            rs = ps.executeQuery( );
            List<Autor> list = new ArrayList<Autor>( );
            while( rs.next( ) ) {
                Integer id = rs.getInt( 1 );
                String nome = rs.getString( 2 );
                String email = rs.getString( 3 );
                Date nascimento = rs.getDate( 4 );
                
                list.add( new Autor(id,nome,email,nascimento) );
                
            }
            return list;
            
        } catch (SQLException sqle) {
            throw new Exception(sqle);
        } finally {
            ConnectionFactory.closeConnection(conn, ps, rs);
        }
    }*/
    
    /**
     * Método responsável por pesquisar um autor
     * @param id - recebe um Inteiro como parâmetro para pesquisar
     * pelo campo autor_id
     * @return objeto Autores
     * @throws java.lang.Exception se não for possível 
     *	 retornar o objeto Autores
     */
   /* public Autor procurarAutor(Integer id)
    throws  Exception {
        PreparedStatement ps = null;
        Connection conn = null;
        ResultSet rs = null;
        
        try {
            conn = this.conn;
            ps = 
		conn.prepareStatement("select * from autores where id=?");
            ps.setInt(1, id);
            rs = ps.executeQuery( );
            if( !rs.next( ) ) {
                throw new
                        Exception( "Não foi encontrado nenhum" +
                        " registro com o ID: " + id );
            }
            
            String nome = rs.getString( 2 );
            String email = rs.getString( 3 );
            Date nascimento = rs.getDate( 4 );
            
            return new Autor(id, nome, email, nascimento) ;
            
        } catch (SQLException sqle) {
            throw new  Exception(sqle);
        } finally {
            ConnectionFactory.closeConnection(conn, ps, rs);
            
        }
    }*/
    
     /**
     * Método que exclui uma linha na tabela Autores
     * @param autor - recebe o objeto Autores
     * @throws  se não for possível excluir o autor
     */   
    /*public void excluir(Autor autor) throws Exception {
        PreparedStatement ps = null;
        Connection conn = null;
        
        if (autor == null)
            throw new
                    Exception("O valor passado não pode ser nulo");
        
        try {
            conn = this.conn;
            ps = 
		conn.prepareStatement("delete from autores where id=?");
            ps.setInt(1, autor.getId( ));
            ps.executeUpdate( );
            
            
        } catch (SQLException sqle) {
            throw new
                    Exception("Erro ao excluir dados:" + sqle);
            
        } finally {
            ConnectionFactory.closeConnection(conn, ps);
        }
        
    }*/
}
