<%@taglib uri="http://java.sun.com/jsf/core" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsf/html" prefix="h" %>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">  </head>
    <body>
        <f:view>
            <h:form id="form1">
                <h:panelGrid columns="3">
                    <f:facet name="header">
                        <h:outputText value="::Cadastro de Clientes"/>
                    </f:facet>
                    <h:outputText value="Nome:" />
                    <h:inputText size="15" id="nome" 
                                 value="#{cliC.cliente.nome}"
                                 required="true"
                                 requiredMessage="Campo obrigatório"/>
                    <h:message for="nome"/>
                    
                    <h:outputText value="E-mail:" />
                    <h:inputText size="30" id="email" 
                                 value="#{cliC.cliente.email}" 
                                 required="true"
                                 requiredMessage="Campo obrigatório"/>
                    <h:message for="email"/>                    
                    
                </h:panelGrid>
                
                <h:commandButton value="Salvar" 
                                 action="#{cliC.salvar}" />			
                <h:commandButton value="Limpar" type="reset" />

                <h:commandLink value="Cancelar" action="cancelar" immediate="true" />    
            </h:form>
        </f:view>
    </body>
</html>
